import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ConfigConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/r/config#base64_encode Config#base64_encode}
    */
    readonly base64Encode?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/r/config#boundary Config#boundary}
    */
    readonly boundary?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/r/config#gzip Config#gzip}
    */
    readonly gzip?: boolean | cdktf.IResolvable;
    /**
    * part block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/r/config#part Config#part}
    */
    readonly part: ConfigPart[] | cdktf.IResolvable;
}
export interface ConfigPart {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/r/config#content Config#content}
    */
    readonly content: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/r/config#content_type Config#content_type}
    */
    readonly contentType?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/r/config#filename Config#filename}
    */
    readonly filename?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudinit/r/config#merge_type Config#merge_type}
    */
    readonly mergeType?: string;
}
export declare function configPartToTerraform(struct?: ConfigPart | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/cloudinit/r/config cloudinit_config}
*/
export declare class Config extends cdktf.TerraformResource {
    static readonly tfResourceType = "cloudinit_config";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/cloudinit/r/config cloudinit_config} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ConfigConfig
    */
    constructor(scope: Construct, id: string, config: ConfigConfig);
    private _base64Encode?;
    get base64Encode(): boolean | cdktf.IResolvable;
    set base64Encode(value: boolean | cdktf.IResolvable);
    resetBase64Encode(): void;
    get base64EncodeInput(): boolean | cdktf.IResolvable | undefined;
    private _boundary?;
    get boundary(): string;
    set boundary(value: string);
    resetBoundary(): void;
    get boundaryInput(): string | undefined;
    private _gzip?;
    get gzip(): boolean | cdktf.IResolvable;
    set gzip(value: boolean | cdktf.IResolvable);
    resetGzip(): void;
    get gzipInput(): boolean | cdktf.IResolvable | undefined;
    get id(): string;
    get rendered(): string;
    private _part?;
    get part(): ConfigPart[] | cdktf.IResolvable;
    set part(value: ConfigPart[] | cdktf.IResolvable);
    get partInput(): cdktf.IResolvable | ConfigPart[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=config.d.ts.map